## regina-normal 5.1

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED (VERSION 2.8.11)
PROJECT (regina)

# Let the user override the package name.
IF(NOT PACKAGE_NAME)
  SET (PACKAGE_NAME regina CACHE STRING
    "The package name used for installation directories.  On some platforms this is 'regina-normal', not 'regina', to avoid conflicts with other software with the same name."
    FORCE)
ENDIF(NOT PACKAGE_NAME)

SET (PACKAGE_PRETTY_NAME Regina)
# Look here for Find___.cmake modules
SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")

# Version
SET (PACKAGE_VERSION 5.1)
SET (SNAPPY_VERSION 2.4)
SET (PACKAGE_STRING "${PACKAGE_PRETTY_NAME} ${PACKAGE_VERSION}")

# Extract major/minor version
# Note: The PACKAGE_VERSION_MAJOR "output" is discarded, since it matches the
# whole string
STRING(REGEX MATCH "^([0-9]+).([0-9]+)" PACKAGE_VERSION_MAJOR "${PACKAGE_VERSION}")
SET (PACKAGE_VERSION_MAJOR ${CMAKE_MATCH_1} )
SET (PACKAGE_VERSION_MINOR ${CMAKE_MATCH_2} )

# Make a release build by default.
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build.  Options are: Debug Release RelWithDebInfo MinSizeRel."
  FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

# Every year I swear I will drop windows support, and this year is no different.
# The windows build (as of November 2015) crashes in the test suite with -O3.
# It looks as though this might be a compiler problem: the ipa-cp-clone
# optimisation has been known to cause crashes under mingw in other projects
# in the past also.
IF (WIN32)
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-ipa-cp-clone")
ENDIF (WIN32)

# Distinguish between the different Regina installation types:
# XDG = standard freedesktop.org filesystem installation in a fixed location.
# Bundle = self-contained app bundle for MacOS that users can drag and drop.
# Windows = self-contained movable install directory for MS Windows.
if (NOT REGINA_INSTALL_TYPE)
  if (APPLE)
    SET (REGINA_DEFAULT_INSTALL_TYPE Bundle)
  elseif (WIN32)
    SET (REGINA_DEFAULT_INSTALL_TYPE Windows)
  else ()
    SET (REGINA_DEFAULT_INSTALL_TYPE XDG)
  endif ()
  SET (REGINA_INSTALL_TYPE ${REGINA_DEFAULT_INSTALL_TYPE} CACHE STRING
    "Choose how Regina installs itself.  Options are: XDG Bundle Windows."
    FORCE)
ENDIF (NOT REGINA_INSTALL_TYPE)
MESSAGE (STATUS "Regina install type: ${REGINA_INSTALL_TYPE}")

# Sanity check the installation type:
IF (${REGINA_INSTALL_TYPE} STREQUAL XDG)
  # No sanity checking needed here (yet).
ELSEIF (${REGINA_INSTALL_TYPE} STREQUAL Bundle)
  IF (NOT APPLE)
    MESSAGE(FATAL_ERROR
      "REGINA_INSTALL_TYPE=Bundle is only supported on MacOSX.")
  ENDIF (NOT APPLE)
ELSEIF (${REGINA_INSTALL_TYPE} STREQUAL Windows)
  IF (NOT WIN32)
    MESSAGE(FATAL_ERROR
      "REGINA_INSTALL_TYPE=Windows is only supported on MS Windows.")
  ENDIF (NOT WIN32)
ELSE()
  MESSAGE(FATAL_ERROR
    "REGINA_INSTALL_TYPE must be one of: XDG Bundle Windows.")
ENDIF()

# Are we installing development files?
IF (${REGINA_INSTALL_TYPE} STREQUAL Bundle)
  SET (REGINA_INSTALL_DEV OFF)
ELSE (${REGINA_INSTALL_TYPE} STREQUAL Bundle)
  SET (REGINA_INSTALL_DEV ON)
ENDIF (${REGINA_INSTALL_TYPE} STREQUAL Bundle)

# Give packagers a way of insisting that every optional component is found.
# Set PACKAGING_MODE=1 to make every component compulsory.
# Set PACKAGING_MODE=1 and PACKAGING_NO_MPI=1 to make every component
# compulsory except for the MPI utilities.
IF(NOT PACKAGING_MODE)
  SET (PACKAGING_MODE OFF CACHE STRING
    "Makes all optional components mandatory, so that cmake will fail if any optional component is not found."
    FORCE)
ENDIF(NOT PACKAGING_MODE)
IF(NOT PACKAGING_NO_MPI)
  SET (PACKAGING_NO_MPI OFF CACHE STRING
    "Leaves MPI as an optional component, even if PACKAGING_MODE is ON."
    FORCE)
ENDIF(NOT PACKAGING_NO_MPI)
IF(PACKAGING_MODE)
  SET(REGINA_MANDATORY TRUE)
  IF(PACKAGING_NO_MPI)
    SET(REGINA_MANDATORY_MPI FALSE)
  ELSE(PACKAGING_NO_MPI)
    SET(REGINA_MANDATORY_MPI TRUE)
  ENDIF(PACKAGING_NO_MPI)
ELSE(PACKAGING_MODE)
  SET(REGINA_MANDATORY FALSE)
  SET(REGINA_MANDATORY_MPI FALSE)
ENDIF(PACKAGING_MODE)

# For pretty logging of optional features at the end of the cmake run:
INCLUDE(MacroLogFeature)

# Modules needed for IOS check and function existence
INCLUDE( CheckCXXSourceCompiles )
INCLUDE( CheckFunctionExists )

# We need to determine threading flags *before* testing for C++11 std::thread.
FIND_PACKAGE(Threads REQUIRED)
IF(NOT Threads_FOUND)
  MESSAGE(FATAL_ERROR "Regina requires threading support.")
ENDIF(NOT Threads_FOUND)
IF(CMAKE_COMPILER_IS_GNUCXX)
  # The FindThreads module picks up -lpthread, not -pthread.
  # This is unfortunate, because std::thread must be built with -pthread
  # under g++; otherwise it builds but throws an exception at runtime.
  SET(CMAKE_CXX_FLAGS "-pthread ${CMAKE_CXX_FLAGS}")
ENDIF(CMAKE_COMPILER_IS_GNUCXX)

# C++11 requirements
INCLUDE(CheckCXX11Features)
SET(HAVE_CXX11_FEATURES TRUE)
NEED_CXX11_FEATURE("auto")
NEED_CXX11_FEATURE("constexpr")
NEED_CXX11_FEATURE("long_long")
NEED_CXX11_FEATURE("nullptr")
NEED_CXX11_FEATURE("rvalue_references")
NEED_CXX11_FEATURE("static_assert")
NEED_CXX11_FEATURE("stdexceptionptr")
NEED_CXX11_FEATURE("stdthread")
NEED_CXX11_FEATURE("variadic_templates")
IF(NOT HAVE_CXX11_FEATURES)
  MESSAGE(FATAL_ERROR "Regina requires C++11 support to compile.")
ENDIF()
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX11_SWITCH}")

# Regina's own cmake scripts:
INCLUDE( ReginaMacros )

# Always include . in the header search path:
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Installation directories
if (${REGINA_INSTALL_TYPE} STREQUAL Bundle)
  # MacOSX app bundle.
  SET (APPDIR ${CMAKE_INSTALL_PREFIX})
  SET (BUNDLEDIR ${APPDIR}/Regina.app)
  SET (BUNDLEDIR_ESCAPED "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/Regina.app")
  SET (PLUGINSDIR ${BUNDLEDIR}/Contents/Plugins)
  SET (PLUGINSDIR_ESCAPED "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/Regina.app/Contents/Plugins")
  SET (RESOURCEDIR ${BUNDLEDIR}/Contents/Resources)
  SET (BINDIR ${BUNDLEDIR}/Contents/MacOS)
  SET (LIBDIR ${BINDIR})
  SET (DATADIR ${RESOURCEDIR})
  SET (INCLUDEDIR ${RESOURCEDIR}/include)
  SET (PKGDATADIR ${DATADIR})
  SET (PYLIBDIR ${LIBDIR}/python)
elseif (${REGINA_INSTALL_TYPE} STREQUAL Windows)
  # MS Windows install.
  SET (APPDIR ${CMAKE_INSTALL_PREFIX}/bin)
  SET (BINDIR ${CMAKE_INSTALL_PREFIX}/bin)
  SET (LIBDIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
  SET (DATADIR ${CMAKE_INSTALL_PREFIX}/share)
  SET (INCLUDEDIR ${CMAKE_INSTALL_PREFIX}/include/${PACKAGE_NAME})
  SET (PKGDATADIR ${DATADIR}/${PACKAGE_NAME})
  SET (PYLIBDIR ${LIBDIR}/${PACKAGE_NAME}/python)
else ()
  # Full install.
  SET (APPDIR ${CMAKE_INSTALL_PREFIX}/bin)
  SET (BINDIR ${CMAKE_INSTALL_PREFIX}/bin)
  SET (LIBDIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
  SET (DATADIR ${CMAKE_INSTALL_PREFIX}/share)
  SET (INCLUDEDIR ${CMAKE_INSTALL_PREFIX}/include/${PACKAGE_NAME})
  SET (PKGDATADIR ${DATADIR}/${PACKAGE_NAME})
  UNSET (PYLIBDIR)
endif ()
SET (HTMLDIR ${PKGDATADIR}/docs)
SET (ICONDIR ${DATADIR}/icons)
SET (MANDIR ${DATADIR}/man)
SET (XDG_APPS_INSTALL_DIR ${DATADIR}/applications)
SET (XDG_MIME_INSTALL_DIR ${DATADIR}/mime/packages)

# Useful build directories
SET (ENGINE_INCLUDES "${PROJECT_SOURCE_DIR}/engine" )
SET (ENGINE_LIBRARY regina-engine)

# RPATH support.
IF (NOT DISABLE_RPATH)
  SET(DISABLE_RPATH OFF CACHE BOOL
    "Do not build with rpath.  This option may break installations in non-standard directories, since executables may be unable to find Regina's libraries.  For installations in standard areas such as /usr however, this option is highly recommended." FORCE)
ENDIF (NOT DISABLE_RPATH)

IF (NOT DISABLE_RPATH)
  if (APPLE)
    set(CMAKE_INSTALL_NAME_DIR ${LIBDIR})
  else (APPLE)
    set(CMAKE_INSTALL_RPATH ${LIBDIR} )
    set(CMAKE_SKIP_BUILD_RPATH FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  endif (APPLE)
ENDIF (NOT DISABLE_RPATH)

# Deprecation warnings.
IF(NOT STRICT_MODE)
  SET (STRICT_MODE OFF CACHE STRING
    "Compiles Regina with -DREGINA_STRICT, which (for supported compilers) issues warnings whenever deprecated code is used."
    FORCE)
ENDIF(NOT STRICT_MODE)
IF(STRICT_MODE)
  SET (CONFIG_STRICT_FLAGS "-DREGINA_STRICT")
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CONFIG_STRICT_FLAGS}")
ELSE(STRICT_MODE)
  SET (CONFIG_STRICT_FLAGS "")
ENDIF(STRICT_MODE)

# i18n checks.
CHECK_CXX_SOURCE_COMPILES("
  #include \"langinfo.h\"
  int main() { nl_langinfo(CODESET); return 0; }"
  LANGINFO_FOUND )
if(NOT LANGINFO_FOUND)
  MESSAGE(WARNING "langinfo not found: UTF-8 will be used always, and the locale-specific encoding will be ignored.")
endif(NOT LANGINFO_FOUND)

IF(NOT USE_BOOST_INT128)
  SET (USE_BOOST_INT128 OFF CACHE STRING
    "Use boost's compile-time 128-bit integer detection, instead of explicitly testing for 128-bit integers here in cmake."
    FORCE)
ENDIF(NOT USE_BOOST_INT128)

CHECK_CXX_SOURCE_COMPILES("
  #include <stdint.h>
  int128_t x;
  uint128_t y;
  int main() { return 0; }"
  INTERNAL_INT128_T_FOUND )

CHECK_CXX_SOURCE_COMPILES("
  #include <stdint.h>
  __int128_t x;
  __uint128_t y;
  int main() { return 0; }"
  INTERNAL___INT128_T_FOUND )

CHECK_CXX_SOURCE_COMPILES("
  unsigned long long x = 0xFFFFFFFFFFFFFFFF;
  int main() { return 0; }"
  NUMERIC_64_FOUND)
CHECK_CXX_SOURCE_COMPILES("
  unsigned long long x = 0xFFFFFFFFFFFFFFFFLL;
  int main() { return 0; }"
  NUMERIC_64_LL_FOUND)

# Dependencies used by all components of Regina
FIND_PACKAGE(ZLIB)
INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
MACRO_LOG_FEATURE(ZLIB_FOUND
  "zlib"
  "Essential: compression support"
  "http://www.gzip.org/zlib/"
  TRUE)

FIND_PACKAGE(LibXml2)
INCLUDE_DIRECTORIES(${LIBXML2_INCLUDE_DIR})
MACRO_LOG_FEATURE(LIBXML2_FOUND
  "libxml2"
  "Essential: XML support"
  "ftp.gnome.org"
  TRUE)

FIND_PACKAGE(GMP)
INCLUDE_DIRECTORIES(${GMP_INCLUDE_DIR})
MACRO_LOG_FEATURE(GMP_FOUND
  "GMP/C"
  "Essential: large integer arithmetic support for C"
  "http://gmplib.org/"
  TRUE)

FIND_PACKAGE(GMPXX)
INCLUDE_DIRECTORIES(${GMPXX_INCLUDE_DIR})
MACRO_LOG_FEATURE(GMPXX_FOUND
  "GMP/C++"
  "Essential: large integer arithmetic support for C++"
  "http://gmplib.org/"
  TRUE)

FIND_PACKAGE(ICONV)
INCLUDE_DIRECTORIES(${ICONV_INCLUDE_DIR})
MACRO_LOG_FEATURE(ICONV_FOUND
  "iconv"
  "Essential: internationalisation support"
  "http://www.gnu.org/s/libiconv/"
  TRUE)

FIND_PACKAGE(Jansson)
INCLUDE_DIRECTORIES(${JANSSON_INCLUDE_DIR})
MACRO_LOG_FEATURE(JANSSON_FOUND
  "Jansson"
  "Essential: JSON support"
  "http://www.digip.org/jansson/"
  TRUE)

FIND_PACKAGE(Boost 1.55 COMPONENTS iostreams python)
INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
MACRO_LOG_FEATURE(Boost_FOUND
  "Boost (>= 1.55)"
  "Essential: C++ components (iostreams, python)"
  "http://www.boost.org/"
  TRUE)

IF (Boost_FOUND)
  SET (OLD_INCLUDES ${CMAKE_REQUIRED_INCLUDES})
  SET (OLD_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
  SET (CMAKE_REQUIRED_INCLUDES ${Boost_INCLUDE_DIR})
  SET (CMAKE_REQUIRED_LIBRARIES ${Boost_IOSTREAMS_LIBRARY})
  # Ensure that boost.iostream was built against zlib.
  # If not, we will display the error message at the very end, after
  # MACRO_DISPLAY_FEATURE_LOG().
  CHECK_CXX_SOURCE_COMPILES("
    #include <boost/iostreams/filtering_streambuf.hpp>
    #include <boost/iostreams/filter/gzip.hpp>

    int main() {
        boost::iostreams::filtering_streambuf<boost::iostreams::input> in;
        in.push(boost::iostreams::gzip_decompressor());
        return 0;
    }"
    BOOST_IOSTREAMS_ZLIB_FOUND)
  SET (CMAKE_REQUIRED_INCLUDES ${OLD_INCLUDES})
  SET (CMAKE_REQUIRED_LIBRARIES ${OLD_LIBRARIES})
ENDIF (Boost_FOUND)

FIND_PACKAGE(PkgConfig)
IF(NOT PKG_CONFIG_FOUND)
  MESSAGE(FATAL_ERROR "Regina requires pkgconfig.")
ENDIF(NOT PKG_CONFIG_FOUND)

IF(NOT QDBM)
  SET (QDBM OFF CACHE STRING
    "Makes Regina build against the older QDBM library, instead of the newer Tokyo Cabinet.  This should only be used on systems (e.g., MinGW) to which Tokyo Cabinet cannot be reliably ported."

=== admin/Makefile ===
##
##  Regina - A Normal Surface Theory Calculator
##  Auxiliary Makefile
##
##  These tools should be used only by the core software maintainers.
##  In fact, there are good arguments that they should not be used at all.
##  Keeping them around though just in case.
##

srcdir = ..

all :

tabs :
	cd $(srcdir); ./replacetabs `find .. -name "*.cpp" -o -name "*.h" -o -name "*.tcc"`
	cd $(srcdir); ./replacetabs `find .. -name "*.txt"`
	cd $(srcdir); ./replacetabs ../qtui/doc/regina/*.docbook
	cd $(srcdir); ./replacetabs ../qtui/doc/regina-xml/*.docbook
	cd $(srcdir); ./replacetabs ../pylib/*.py

=== engine/CMakeLists.txt ===
# Engine

# Note: Any flags that need to be picked up by internal compiled engine tools
# (such as mkcensusdb) need to appear *before* the list of subdirectories.

# Pick up generated engine headers (e.g., regina-config.h) as well as
# Regina's standard engine headers.
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/engine)
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR}/engine)

# The tokyocabinet library is only used internally by the engine (i.e., it
# never appears in the engine headers, only the .cpp sources).
# Therefore we include it only here within engine/, not globally.
INCLUDE_DIRECTORIES(${TOKYOCABINET_INCLUDE_DIRS})
LINK_DIRECTORIES(${TOKYOCABINET_LIBRARY_DIRS})

SET ( SOURCES engine )
# Each of these subdirectories modifies the SOURCE variable,
# adding more source files
ADD_SUBDIRECTORY("algebra")
ADD_SUBDIRECTORY("angle")
ADD_SUBDIRECTORY("census")
ADD_SUBDIRECTORY("data")
ADD_SUBDIRECTORY("dim2")
ADD_SUBDIRECTORY("dim4")
ADD_SUBDIRECTORY("enumerate")
ADD_SUBDIRECTORY("file")
ADD_SUBDIRECTORY("foreign")
ADD_SUBDIRECTORY("generic")
ADD_SUBDIRECTORY("hypersurface")
ADD_SUBDIRECTORY("libnormaliz")
ADD_SUBDIRECTORY("manifold")
ADD_SUBDIRECTORY("maths")
ADD_SUBDIRECTORY("packet")
ADD_SUBDIRECTORY("progress")
ADD_SUBDIRECTORY("snappea")
ADD_SUBDIRECTORY("split")
ADD_SUBDIRECTORY("subcomplex")
ADD_SUBDIRECTORY("surfaces")
ADD_SUBDIRECTORY("syntax")
ADD_SUBDIRECTORY("treewidth")
ADD_SUBDIRECTORY("triangulation")
ADD_SUBDIRECTORY("utilities")

# Some C files need to be compiled using the C++ compiler (e.g., snappea,
# where we have added C++ namespaces).
SET_SOURCE_FILES_PROPERTIES( ${SOURCES_C_AS_CPP} PROPERTIES LANGUAGE CXX )

ADD_DEFINITIONS(-DREGINA_DLL_EXPORTS=1)

ADD_LIBRARY("regina-engine" SHARED ${SOURCES} )
# All of the libraries that appear in ENGINE_LINK_LIBRARIES feature in
# the engine headers, which means they may be expose to third-party apps
# that build against libregina-engine.
# Note: PUBLIC and PRIVATE only appeard in CMake 2.8.12.
# For compatibility back to 2.8.7 we use LINK_PUBLIC and LINK_PRIVATE instead.
SET(ENGINE_LINK_LIBRARIES ${LIBXML2_LIBRARIES} ${JANSSON_LIBRARIES} ${GMP_LIBRARIES} ${GMPXX_LIBRARIES} ${ZLIB_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
TARGET_LINK_LIBRARIES(regina-engine
  LINK_PUBLIC ${ENGINE_LINK_LIBRARIES}
  LINK_PRIVATE ${ICONV_LIBRARY} ${Boost_IOSTREAMS_LIBRARY} ${TOKYOCABINET_LIBRARIES})
SET_TARGET_PROPERTIES(regina-engine PROPERTIES VERSION ${PACKAGE_VERSION})
SET_TARGET_PROPERTIES(regina-engine PROPERTIES SOVERSION ${PACKAGE_VERSION})

SET( HEADERS ${HEADERS} docs.h engine.h output.h regina-core.h )
SET( MANS ${MANS} regina-engine-config.1 )

# Build space-separated lists of flags for regine-engine-config:
GET_DIRECTORY_PROPERTY(ENGINE_INCLUDE_DIRECTORIES DIRECTORY .. INCLUDE_DIRECTORIES)
foreach(arg ${ENGINE_INCLUDE_DIRECTORIES})
  SET(RECONFIG_INCLUDE_FLAGS "${RECONFIG_INCLUDE_FLAGS} -I${arg}")
endforeach(arg ${ENGINE_INCLUDE_DIRECTORIES})
foreach(arg ${ENGINE_LINK_LIBRARIES})
  SET(RECONFIG_LINK_FLAGS "${RECONFIG_LINK_FLAGS} ${arg}")
endforeach(arg ${ENGINE_LINK_LIBRARIES})
CONFIGURE_FILE (
  regina-engine-config.in
  "${PROJECT_BINARY_DIR}/engine/regina-engine-config"
  @ONLY
)

INSTALL(TARGETS regina-engine
  LIBRARY DESTINATION ${LIBDIR}
  RUNTIME DESTINATION ${BINDIR}
  COMPONENT Runtime)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES ${HEADERS} DESTINATION ${INCLUDEDIR} COMPONENT Development)
  INSTALL(FILES ${CMAKE_BINARY_DIR}/engine/regina-config.h DESTINATION ${INCLUDEDIR} COMPONENT Development)
  INSTALL(PROGRAMS ${PROJECT_BINARY_DIR}/engine/regina-engine-config DESTINATION bin COMPONENT Development)
  INSTALL(FILES regina-engine-config.1 DESTINATION ${MANDIR}/man1 COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

# Miscellaneous extras:
ADD_SUBDIRECTORY("doxygen")

=== examples/CMakeLists.txt ===

SET(examplesdir ${PKGDATADIR}/examples)

SET(examples_files
  README.txt
  closed-hyp-census.rga
  closed-or-census.rga
  closed-nor-census.rga
  cusped-hyp-or-census.rga
  cusped-hyp-nor-census.rga
  hyp-knot-link-census.rga
  sample-misc.rga
  progress.py
  progress.session
  tree.py
  tree.session
  triangulation.py
  triangulation.session
  )
INSTALL(FILES ${examples_files} DESTINATION ${examplesdir})

=== python/CMakeLists.txt ===
SET ( SOURCES globalarray safeheldtype modulemain )
ADD_SUBDIRECTORY("algebra")
ADD_SUBDIRECTORY("angle")
ADD_SUBDIRECTORY("census")
ADD_SUBDIRECTORY("dim2")
ADD_SUBDIRECTORY("dim3")
ADD_SUBDIRECTORY("dim4")
ADD_SUBDIRECTORY("file")
ADD_SUBDIRECTORY("foreign")
ADD_SUBDIRECTORY("generic")
ADD_SUBDIRECTORY("hypersurface")
ADD_SUBDIRECTORY("manifold")
ADD_SUBDIRECTORY("maths")
ADD_SUBDIRECTORY("packet")
ADD_SUBDIRECTORY("progress")
ADD_SUBDIRECTORY("snappea")
ADD_SUBDIRECTORY("split")
ADD_SUBDIRECTORY("srcutils")
ADD_SUBDIRECTORY("subcomplex")
ADD_SUBDIRECTORY("surfaces")
ADD_SUBDIRECTORY("treewidth")
ADD_SUBDIRECTORY("utilities")
ADD_SUBDIRECTORY("testsuite")

# The module itself is built in the regina/ subdirectory, so that we can
# import the module directly from the source tree if we like.
ADD_SUBDIRECTORY("regina")

# regina-python needs special environment variables when running on a
# 64-bit mac with a 32-bit build.
SET (OSX_PYTHON_32 0)
IF (APPLE)
  IF (CMAKE_OSX_ARCHITECTURES STREQUAL "i386")
    SET (OSX_PYTHON_32 1)
  ENDIF (CMAKE_OSX_ARCHITECTURES STREQUAL "i386")
ENDIF (APPLE)

# The startup script for users:
CONFIGURE_FILE (
  "${PROJECT_SOURCE_DIR}/python/regina-python.in"
  "${PROJECT_BINARY_DIR}/python/regina-python"
  @ONLY
)

INSTALL(PROGRAMS ${PROJECT_BINARY_DIR}/python/regina-python DESTINATION ${BINDIR} COMPONENT Runtime)

=== testsuite/CMakeLists.txt ===
# Give the test suite a way to locate the data files shipped with
# Regina's calculation engine.
SET_PROPERTY ( DIRECTORY
  PROPERTY COMPILE_DEFINITIONS
    TESTSUITE_CENSUS_DIR=\"${PROJECT_BINARY_DIR}/engine/data/census\"
)

SET ( SOURCES
  exhaustive
  runalltests
  testsuite
  )
# Each of these subdirectories modifies the SOURCES variable,
# adding more source files
ADD_SUBDIRECTORY("algebra")
ADD_SUBDIRECTORY("angle")
ADD_SUBDIRECTORY("census")
ADD_SUBDIRECTORY("dim2")
ADD_SUBDIRECTORY("dim3")
ADD_SUBDIRECTORY("dim4")
ADD_SUBDIRECTORY("generic")
ADD_SUBDIRECTORY("maths")
ADD_SUBDIRECTORY("snappea")
ADD_SUBDIRECTORY("subcomplex")
ADD_SUBDIRECTORY("surfaces")
ADD_SUBDIRECTORY("utilities")

INCLUDE_DIRECTORIES(${ENGINE_INCLUDES})
INCLUDE_DIRECTORIES(${CPPUNIT_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR}/engine)
ADD_EXECUTABLE(regtestsuite ${SOURCES})
TARGET_LINK_LIBRARIES(regtestsuite ${ENGINE_LIBRARY} ${CPPUNIT_LIBRARY}) # TODO

ADD_TEST(cpp-test regtestsuite)

=== utils/CMakeLists.txt ===
include_directories(${ENGINE_INCLUDES})
include_directories(${CMAKE_BINARY_DIR}/engine)
include_directories(${POPT_INCLUDE_DIR})

set(UTILS
  censuslookup
  regconcat
  regconvert
  regfiledump
  regfiletype
  sigcensus
  tricensus
  trisetcmp
  )

foreach(UTIL ${UTILS})
  string(REGEX REPLACE _ - SOURCE_FILE ${UTIL})
  add_executable(${UTIL} ${SOURCE_FILE})
  target_link_libraries(${UTIL} ${ENGINE_LIBRARY} ${POPT_LIBRARY})
endforeach(UTIL)

if(MPI_FOUND)
  add_subdirectory(mpi)
endif(MPI_FOUND)

install(TARGETS ${UTILS} DESTINATION ${BINDIR} COMPONENT Runtime)

=== docs/engine/CMakeLists.txt ===

# TODO: The doxygen files generated in the build tree are not removed
# by "make clean".

ADD_CUSTOM_COMMAND(OUTPUT index.html
  COMMAND ${DOXYGEN_EXECUTABLE} ${PROJECT_BINARY_DIR}/engine/doxygen/docs.conf
  COMMAND cp `find "${PROJECT_SOURCE_DIR}/engine" -name '*.png'` .
  )

ADD_CUSTOM_TARGET(docs ALL DEPENDS index.html)

INSTALL(
  DIRECTORY ${PROJECT_BINARY_DIR}/docs/engine/
  DESTINATION ${PKGDATADIR}/engine-docs
  FILES_MATCHING
  PATTERN CMakeFiles EXCLUDE
  PATTERN "*.css"
  PATTERN "*.dot"
  PATTERN "*.gif"
  PATTERN "*.html"
  PATTERN "*.jpg"
  PATTERN "*.png"
  PATTERN "*.txt"
  )

=== docs/man/CMakeLists.txt ===

SET(man1dir ${MANDIR}/man1)

SET(man1_files
  censuslookup.1
  regconcat.1
  regconvert.1
  regfiledump.1
  regfiletype.1
  sigcensus.1
  tricensus.1
  tricensus-mpi.1
  tricensus-mpi-status.1
  trisetcmp.1
  regina-gui.1
  regina-python.1
  )
INSTALL(FILES ${man1_files} DESTINATION ${man1dir} COMPONENT Runtime)

=== engine/algebra/CMakeLists.txt ===
# algebra

# Files to compile
SET ( FILES
  abeliangroup
  grouppresentation
  homgrouppresentation
  markedabeliangroup
  xmlalgebrareader
  )

# Prepend folder name
FOREACH ( SOURCE_FILE ${FILES} )
  SET ( SOURCES ${SOURCES} algebra/${SOURCE_FILE})
ENDFOREACH(SOURCE_FILE)
SET(SOURCES ${SOURCES} PARENT_SCOPE)

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    abeliangroup.h
    nabeliangroup.h
    grouppresentation.h
    ngrouppresentation.h
    homgrouppresentation.h
    nhomgrouppresentation.h
    markedabeliangroup.h
    nmarkedabeliangroup.h
    xmlalgebrareader.h
    DESTINATION ${INCLUDEDIR}/algebra COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== engine/data/CMakeLists.txt ===

ADD_SUBDIRECTORY("census")
ADD_SUBDIRECTORY("snappea")

=== engine/dim4/CMakeLists.txt ===

if (${REGINA_INSTALL_DEV})
  INSTALL(FILES
    dim4boundarycomponent.h
    dim4component.h
    dim4edge.h
    dim4exampletriangulation.h
    dim4facetpairing.h
    dim4triangle.h
    dim4isomorphism.h
    dim4pentachoron.h
    dim4tetrahedron.h
    dim4triangulation.h
    dim4vertex.h
    DESTINATION ${INCLUDEDIR}/dim4 COMPONENT Development)
endif (${REGINA_INSTALL_DEV})

=== debian/changelog ===
regina-normal (5.1-6ubuntu1) focal; urgency=medium

  * Build-depend on python2-dev.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 13 Jan 2020 14:21:47 +0100

regina-normal (5.1-6build1) focal; urgency=medium

  * No-change rebuild to generate dependencies on python2.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Dec 2019 12:45:25 +0000

regina-normal (5.1-6) unstable; urgency=low

  * Added NEWS.gz symlinks in doc directories that point to HIGHLIGHTS.txt.gz.
  * Bumped standards-version to 4.2.1.3.

 -- Ben Burton <bab@debian.org>  Sun, 28 Oct 2018 08:14:58 +1000

regina-normal (5.1-5) unstable; urgency=low

  * Reorganised debian/rules to use the standard dh sequence instead of
    many individual dh_* calls.
  * Replaced manual make/cmake calls in debian/rules with dh_auto_*.
  * The package build now respects dpkg-buildflags, and (as a result)
    includes additional security hardening features.
  * Dropped the old debian menu entry for regina-python (and the corresponding
    pixmap), since the debian menu system is being phased out.
  * Bumped standards-version to 4.1.3.0.

 -- Ben Burton <bab@debian.org>  Fri, 23 Mar 2018 09:01:58 +1000

regina-normal (5.1-4) unstable; urgency=low

  * Switched packaging to dpkg-source 3.0 (quilt) format.
  * The examples, API docs and user handbook have moved from beneath
    /usr/share/doc/ into /usr/share/regina-normal/, to respect preferred
    behaviour in debian policy.  The old directories beneath /usr/share/doc/
    have been replaced with symlinks.
  * Removed the arm64 -O2 workaround from debian/rules, which was to avoid
    a gcc breakage that I believe is now fixed.
  * Build with -g so that the -dbgsym packages contain real debug symbols.
    These symbols are still stripped out as usual in the mainstream packages.
  * Switched to debhelper compatibility level 11; now using
    dh_missing --fail-missing instead of dh_install --list-missing.

 -- Ben Burton <bab@debian.org>  Sun, 18 Mar 2018 07:35:09 +1000

regina-normal (5.1-3) unstable; urgency=low

  * Bumped standards-version to 4.1.1.
  * Updated the debian watch file to point to github (not sourceforge).
  * Switched to debhelper compatibility level 9.
  * Package regina-normal now just recommends regina-normal-doc instead of
    depending on it, following the recent policy change.
  * Changed priority from extra to optional.

 -- Ben Burton <bab@debian.org>  Sat, 17 Mar 2018 13:00:57 +1000

regina-normal (5.1-2) unstable; urgency=low

  * Added missing #include to build against gcc-7 (closes: #853639).

 -- Ben Burton <bab@debian.org>  Sun, 13 Aug 2017 13:09:06 +1000

regina-normal (5.1-1) unstable; urgency=low

  * New upstream release.
  * Added build-depends on libjansson-dev, which is required as of Regina 5.1.
  * Removed build-depends on libsource-highlight-dev, which is no longer used.

 -- Ben Burton <bab@debian.org>  Sat, 17 Dec 2016 09:27:49 +1100

regina-normal (5.0-3) unstable; urgency=low

  * Updated the debian watch file.

 -- Ben Burton <bab@debian.org>  Thu,  6 Oct 2016 14:17:53 +1000

regina-normal (5.0-2) unstable; urgency=low

  * Build with -O2 instead of -O3 on arm64, to avoid assembly errors.

 -- Ben Burton <bab@debian.org>  Thu,  6 Oct 2016 14:17:53 +1000

regina-normal (5.0-1) unstable; urgency=low

  * New upstream release.
  * New build-depends: switched from Qt4 to Qt5, and also added
    libboost-iostreams-dev and libgraphviz-dev.
  * Added debian/watch (thanks to bartm).
  * Removed regina-gui from the debian menu system, following the recent
    policy update.  Kept the menu entry for regina-python, since this
    command-line application does not provide a .desktop file.
  * Bumped standards-version to 3.9.8.

 -- Ben Burton <bab@debian.org>  Tue, 20 Sep 2016 10:03:24 +1000

regina-normal (4.96-4) unstable; urgency=low

  * Fix FTBFS on some architectures, which was due to an assumption in the
    snappea kernel that char was signed (closes: #836678).

 -- Ben Burton <bab@debian.org>  Mon, 05 Sep 2016 12:18:35 +1000

regina-normal (4.96-3) unstable; urgency=low

  * Fix FTBFS with gcc-6 due to ambiguity in resolving std::make_tuple vs
    boost::python::make_tuple (closes: #811680).
  * Altered previous NMU patch to be consistent with how this was fixed
    upstream (thanks Anton for the NMU).

 -- Ben Burton <bab@debian.org>  Sat, 02 Jul 2016 09:38:33 +1000

regina-normal (4.96-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS due to ambiguous call of overloaded method. (Closes: #808456)

 -- Anton Gladky <gladk@debian.org>  Sat, 02 Jan 2016 00:00:47 +0100

regina-normal (4.96-2) unstable; urgency=low

  * Now installs the utility /usr/bin/censuslookup, which was inadvertently
    omitted from 4.96-1 (closes: #769700).  Also installs the corresponding
    manpage.

 -- Ben Burton <bab@debian.org>  Sat, 15 Nov 2014 22:01:46 +0530

regina-normal (4.96-1) unstable; urgency=low

  * New upstream release.

 -- Ben Burton <bab@debian.org>  Fri, 29 Aug 2014 17:37:46 +1000

regina-normal (4.95-1) unstable; urgency=low

  * New upstream release.
  * The python module is now installed in a standard location beneath
    /usr/lib/python2.7/dist-packages.
  * Switched python packaging from python-support to dh_python2.

 -- Ben Burton <bab@debian.org>  Sat,  2 Nov 2013 11:44:32 -0400

regina-normal (4.94-1) unstable; urgency=low

  * New upstream release.

 -- Ben Burton <bab@debian.org>  Tue, 17 Sep 2013 06:58:42 +1000

regina-normal (4.93-1.1) unstable; urgency=low

  * Non-maintainer upload.

  [ Peter Michael Green ]
  * Force python library location to new multiarch path.
    Closes: #713360
  * Bump python-dev build-depends for multiarch.

  [ gregor herrmann ]
  * Build-depend on dpkg-dev >= 1.16.0 for multiarch support.

 -- gregor herrmann <gregoa@debian.org>  Sat, 13 Jul 2013 17:07:24 +0200

regina-normal (4.93-1) unstable; urgency=low

  * New upstream release.

 -- Ben Burton <bab@debian.org>  Tue, 29 May 2012 08:46:45 +1000


=== debian/control ===
Source: regina-normal
Section: math
Priority: optional
Maintainer: Ben Burton <bab@debian.org>
Homepage: http://regina-normal.github.io/
Build-Depends:
    debhelper (>= 11),
    dh-python,
    cmake (>= 2.8.7),
    doxygen,
    libboost-iostreams-dev,
    libboost-python-dev (>= 1.39.0),
    libcppunit-dev (>= 1.10.2-4),
    libgmp-dev (>= 4.1.4-10),
    libgraphviz-dev,
    libjansson-dev,
    libpopt-dev,
    libqt5svg5-dev,
    libtokyocabinet-dev,
    libxml2-dev,
    mpi-default-dev,
    pkg-config,
    python2-dev (>= 2.7.3-10~),
    qtbase5-dev,
    shared-mime-info,
    xsltproc,
    zlib1g-dev,
    dpkg-dev (>= 1.16.0)
Standards-Version: 4.2.1.3

Package: regina-normal
Architecture: any
Section: math
Pre-Depends: ${misc:Pre-Depends}
Depends:
    ${shlibs:Depends},
    ${perl:Depends},
    ${python:Depends},
    ${misc:Depends}
Recommends: regina-normal-doc (>= 5.1-0), gap, evince | pdf-viewer
Suggests: regina-normal-dev, regina-normal-mpi
Description: mathematical software for low-dimensional topology
 Regina is a software package for 3-manifold and 4-manifold topologists,
 with a focus on triangulations, normal surfaces and angle structures.
 .
 For 3-manifolds, it includes high-level tasks such as 3-sphere recognition,
 connected sum decomposition and Hakenness testing, comes with a rich
 database of census manifolds, and incorporates the SnapPea kernel for
 working with hyperbolic manifolds.  For 4-manifolds, it offers a range of
 combinatorial and algebraic tools, plus support for normal hypersurfaces.
 .
 Regina comes with a full graphical user interface, as well as Python bindings
 and a low-level C++ programming interface.
 .
 This package includes the graphical user interface and the command-line
 Python interface.  The users' handbook and the API documentation are in
 the separate package regina-normal-doc, and the MPI-enabled utilities for
 high-performance clusters are in the separate package regina-normal-mpi.

Package: regina-normal-dev
Architecture: any
Section: libdevel
Depends:
    regina-normal (= ${binary:Version}),
    libboost-dev,
    libgmp-dev,
    libxml2-dev,
    zlib1g-dev,
    ${misc:Depends}
Suggests: regina-normal-doc
Description: development files for Regina, the topology software
 Regina is a software package for low-dimensional topologists.  This package
 provides development files for compiling Regina's mathematical engine into
 other projects.
 .
 The calculation engine is provided as a C++ shared library.  For complete
 API documentation, see the package regina-normal-doc.
 .
 Regina focuses on the study of 3-manifold and 4-manifold triangulations,
 normal surfaces, and angle structures.  For Regina's standard graphical
 user interface, and for more information about what Regina can do, see
 the package regina-normal.

Package: regina-normal-mpi
Architecture: any
Section: math
Depends:
    mpi-default-bin,
    ${shlibs:Depends},
    ${perl:Depends},
    ${misc:Depends}
Replaces: regina-normal (<= 4.3.1-6)
Description: MPI utilities for Regina, the topology software
 Regina is a software package for low-dimensional topologists.  This package
 contains the components of Regina designed to run large parallel computations
 on a high-performance cluster using MPI.
 .
 These components are built against the default implementation of MPI,
 and must be run under the default MPI runtime environment (as found
 in the package mpi-default-bin).
 .
 Regina focuses on the study of 3-manifold and 4-manifold triangulations,
 normal surfaces, and angle structures.  For Regina's standard graphical
 user interface, and for more information about what Regina can do, see
 the package regina-normal.

Package: regina-normal-doc
Architecture: all
Section: doc
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}
Recommends: iceweasel | www-browser
Suggests: regina-normal, regina-normal-dev
Breaks: regina-normal (<< 4.6-2)
Replaces: regina-normal (<< 4.6-2)
Description: documentation for Regina, the topology software
 Regina is a software package for low-dimensional topologists.  This package
 provides a rich users' handbook, complete API documentation for the C++
 calculation engine and Python bindings, and the full specification for
 Regina's XML data file format.
 .
 Regina focuses on the study of 3-manifold and 4-manifold triangulations,
 normal surfaces, and angle structures.  For Regina's standard graphical
 user interface, and for more information about what Regina can do, see
 the package regina-normal.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with python2

# Upgrade optimisation flags:
export DEB_CFLAGS_MAINT_STRIP = -O2
export DEB_CXXFLAGS_MAINT_STRIP = -O2
export DEB_CFLAGS_MAINT_APPEND = -O3 -DNDEBUG
export DEB_CXXFLAGS_MAINT_APPEND = -O3 -DNDEBUG

# Find the default python version so we can pass it to cmake.  This 
# keeps things sane when multiple python*-dev packages are installed.
pyver = $(subst python,,$(shell /usr/bin/pyversions --default))

DEB_HOST_MULTIARCH ?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_auto_configure:
	dh_auto_configure -- \
		-DPACKAGE_NAME=regina-normal -DPACKAGING_MODE=1 \
		-DPYTHON_EXECUTABLE=/usr/bin/python${pyver} \
		-DPYTHON_LIBRARY=/usr/lib/$(DEB_HOST_MULTIARCH)/libpython${pyver}.so \
		-DDISABLE_RPATH=1

override_dh_auto_build:
	dh_auto_build -- VERBOSE=1

override_dh_auto_test:
	dh_auto_test -- ARGS=-V

override_dh_missing:
	dh_missing --fail-missing

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.txt

override_dh_compress:
	dh_compress -X.bz2 -X.css -X.docbook -X.rga

override_dh_strip_nondeterminism:
	# PNGs are not compiled during the build, so do not touch them now.
	dh_strip_nondeterminism -X.png
